--- Partially generated by a program. Never mind the readability.
--
-- april 26 2005
-- video levels for the serration and equalizing pulses are provied
-- in the vhdl code.  video lines (starting from lines 10 to 262 are 
-- generated exclusively by data stored in the SDRAM. Note that the
-- whole NTSC field could have generated by data in SDRAM (no logic
-- needed in VHDL)
-- Acknowlegments: 
-- Without the original SDRAM memtest, none of this would have been
-- possible.

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use WORK.common.all;
use WORK.rand.all;

--- this is the XSA memtest modified to get video data
package this_dont_matter is
	component ntsc
	generic(
		DATA_WIDTH: natural := 16;			-- memory data width
		ADDR_WIDTH: natural := 23;			-- memory address width
		BEG_TEST: natural := 0;				-- beginning test range address
		END_TEST: natural := 8_388_607		-- ending test range address
	);
	port(
		clk: in std_logic;				-- master clock input
		rst: in std_logic;				-- active-high reset
		ack: in std_logic;				-- memory operation complete indicator
		dIn: in unsigned(DATA_WIDTH-1 downto 0);		-- data from memory
		rd: out std_logic;					-- memory read control signal
		wr: out std_logic;					-- memory write control signal
		addr: out unsigned(ADDR_WIDTH-1 downto 0);	-- address to memory
		dOut: out unsigned(DATA_WIDTH-1 downto 0);	-- data to memory
		progress: out std_logic_vector(1 downto 0);	-- memory test progress indicator
		err: out std_logic;						-- memory error flag
		---- NTSC
	    reset: in std_logic;
		ntsc_clk: in std_logic;
		data: out unsigned(7 downto 0)  -- DAC output
	);
	end component;
end package this_dont_matter;

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use WORK.common.all;
use WORK.rand.all;
-- THE FOLLOWING CRAP IS NEEDED TO DO COUNTER<=COUNTER+1; 
-- thanks to the sick creativity of VHDL designers
use ieee.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity ntsc is
	generic(
		DATA_WIDTH: natural := 16;			-- memory data width
		ADDR_WIDTH: natural := 23;			-- memory address width
		BEG_TEST: natural := 0;				-- beginning test range address
		END_TEST: natural := 8_388_607		-- ending test range address
	);
	port(
		clk: in std_logic;				-- master clock input
		rst: in std_logic;				-- active-high reset
		ack: in std_logic;				-- memory operation complete indicator
		dIn: in unsigned(DATA_WIDTH-1 downto 0);		-- data from memory
		rd: out std_logic;					-- memory read control signal
		wr: out std_logic;					-- memory write control signal
		addr: out unsigned(ADDR_WIDTH-1 downto 0);	-- address to memory
		dOut: out unsigned(DATA_WIDTH-1 downto 0);	-- data to memory
		progress: out std_logic_vector(1 downto 0);	-- memory test progress indicator
		err: out std_logic;					-- memory error flag
		---- NTSC
	    reset: in std_logic;
		ntsc_clk: in std_logic;
		data: out unsigned(7 downto 0) -- DAC output
	);
end ntsc;

-- Much of the code below is from the original SDRAM controller test (www.xess.com)
architecture arch of ntsc is
	
	-- states of the memory tester state machine
	type testState is (
		INIT,			-- init
		LOAD,			-- load memory with pseudo-random data
		COMPARE,	-- compare memory contents with pseudo-random data
		STOP			-- stop and indicate memory status
	);
	signal state_r, state_next: testState;		-- state register and next state

	-- registers
	signal addr_r, addr_next: unsigned(ADDR_WIDTH-1 downto 0);	-- address register
	signal err_r, err_next: std_logic;			-- error flag

	-- internal signals
	signal ldRand: std_logic;		-- load random number gen with seed value
	signal ckeRand: std_logic;		-- clock-enable for random number gen
	signal randNum: unsigned(dOut'range);	-- random number from generator
	signal seed: unsigned(dIn'range);	 	-- random number starting seed

-- brought over from the NTSC project
---component IBUFG
---port(I: in std_logic; O: out std_logic);
---end component;
signal counter, counter_r: std_logic_vector(11 downto 0);

type lines is (
LINE_001,
LINE_002,
LINE_003,
LINE_004,
LINE_005,
LINE_006,
LINE_007,
LINE_008,
LINE_009,
LINE_010,
LINE_011,
LINE_012,
LINE_013,
LINE_014,
LINE_015,
LINE_016,
LINE_017,
LINE_018,
LINE_019,
LINE_020,
LINE_021,
LINE_022,
LINE_023,
LINE_024,
LINE_025,
LINE_026,
LINE_027,
LINE_028,
LINE_029,
LINE_030,
LINE_031,
LINE_032,
LINE_033,
LINE_034,
LINE_035,
LINE_036,
LINE_037,
LINE_038,
LINE_039,
LINE_040,
LINE_041,
LINE_042,
LINE_043,
LINE_044,
LINE_045,
LINE_046,
LINE_047,
LINE_048,
LINE_049,
LINE_050,
LINE_051,
LINE_052,
LINE_053,
LINE_054,
LINE_055,
LINE_056,
LINE_057,
LINE_058,
LINE_059,
LINE_060,
LINE_061,
LINE_062,
LINE_063,
LINE_064,
LINE_065,
LINE_066,
LINE_067,
LINE_068,
LINE_069,
LINE_070,
LINE_071,
LINE_072,
LINE_073,
LINE_074,
LINE_075,
LINE_076,
LINE_077,
LINE_078,
LINE_079,
LINE_080,
LINE_081,
LINE_082,
LINE_083,
LINE_084,
LINE_085,
LINE_086,
LINE_087,
LINE_088,
LINE_089,
LINE_090,
LINE_091,
LINE_092,
LINE_093,
LINE_094,
LINE_095,
LINE_096,
LINE_097,
LINE_098,
LINE_099,
LINE_100,
LINE_101,
LINE_102,
LINE_103,
LINE_104,
LINE_105,
LINE_106,
LINE_107,
LINE_108,
LINE_109,
LINE_110,
LINE_111,
LINE_112,
LINE_113,
LINE_114,
LINE_115,
LINE_116,
LINE_117,
LINE_118,
LINE_119,
LINE_120,
LINE_121,
LINE_122,
LINE_123,
LINE_124,
LINE_125,
LINE_126,
LINE_127,
LINE_128,
LINE_129,
LINE_130,
LINE_131,
LINE_132,
LINE_133,
LINE_134,
LINE_135,
LINE_136,
LINE_137,
LINE_138,
LINE_139,
LINE_140,
LINE_141,
LINE_142,
LINE_143,
LINE_144,
LINE_145,
LINE_146,
LINE_147,
LINE_148,
LINE_149,
LINE_150,
LINE_151,
LINE_152,
LINE_153,
LINE_154,
LINE_155,
LINE_156,
LINE_157,
LINE_158,
LINE_159,
LINE_160,
LINE_161,
LINE_162,
LINE_163,
LINE_164,
LINE_165,
LINE_166,
LINE_167,
LINE_168,
LINE_169,
LINE_170,
LINE_171,
LINE_172,
LINE_173,
LINE_174,
LINE_175,
LINE_176,
LINE_177,
LINE_178,
LINE_179,
LINE_180,
LINE_181,
LINE_182,
LINE_183,
LINE_184,
LINE_185,
LINE_186,
LINE_187,
LINE_188,
LINE_189,
LINE_190,
LINE_191,
LINE_192,
LINE_193,
LINE_194,
LINE_195,
LINE_196,
LINE_197,
LINE_198,
LINE_199,
LINE_200,
LINE_201,
LINE_202,
LINE_203,
LINE_204,
LINE_205,
LINE_206,
LINE_207,
LINE_208,
LINE_209,
LINE_210,
LINE_211,
LINE_212,
LINE_213,
LINE_214,
LINE_215,
LINE_216,
LINE_217,
LINE_218,
LINE_219,
LINE_220,
LINE_221,
LINE_222,
LINE_223,
LINE_224,
LINE_225,
LINE_226,
LINE_227,
LINE_228,
LINE_229,
LINE_230,
LINE_231,
LINE_232,
LINE_233,
LINE_234,
LINE_235,
LINE_236,
LINE_237,
LINE_238,
LINE_239,
LINE_240,
LINE_241,
LINE_242,
LINE_243,
LINE_244,
LINE_245,
LINE_246,
LINE_247,
LINE_248,
LINE_249,
LINE_250,
LINE_251,
LINE_252,
LINE_253,
LINE_254,
LINE_255,
LINE_256,
LINE_257,
LINE_258,
LINE_259,
LINE_260,
LINE_261,
LINE_262,
LINE_263,
LINE_264,
LINE_265,
LINE_266,
LINE_267,
LINE_268,
LINE_269,
LINE_270,
LINE_271,
LINE_272,
LINE_273,
LINE_274,
LINE_275,
LINE_276,
LINE_277,
LINE_278,
LINE_279,
LINE_280,
LINE_281,
LINE_282,
LINE_283,
LINE_284,
LINE_285,
LINE_286,
LINE_287,
LINE_288,
LINE_289,
LINE_290,
LINE_291,
LINE_292,
LINE_293,
LINE_294,
LINE_295,
LINE_296,
LINE_297,
LINE_298,
LINE_299,
LINE_300,
LINE_301,
LINE_302,
LINE_303,
LINE_304,
LINE_305,
LINE_306,
LINE_307,
LINE_308,
LINE_309,
LINE_310,
LINE_311,
LINE_312,
LINE_313,
LINE_314,
LINE_315,
LINE_316,
LINE_317,
LINE_318,
LINE_319,
LINE_320,
LINE_321,
LINE_322,
LINE_323,
LINE_324,
LINE_325,
LINE_326,
LINE_327,
LINE_328,
LINE_329,
LINE_330,
LINE_331,
LINE_332,
LINE_333,
LINE_334,
LINE_335,
LINE_336,
LINE_337,
LINE_338,
LINE_339,
LINE_340,
LINE_341,
LINE_342,
LINE_343,
LINE_344,
LINE_345,
LINE_346,
LINE_347,
LINE_348,
LINE_349,
LINE_350,
LINE_351,
LINE_352,
LINE_353,
LINE_354,
LINE_355,
LINE_356,
LINE_357,
LINE_358,
LINE_359,
LINE_360,
LINE_361,
LINE_362,
LINE_363,
LINE_364,
LINE_365,
LINE_366,
LINE_367,
LINE_368,
LINE_369,
LINE_370,
LINE_371,
LINE_372,
LINE_373,
LINE_374,
LINE_375,
LINE_376,
LINE_377,
LINE_378,
LINE_379,
LINE_380,
LINE_381,
LINE_382,
LINE_383,
LINE_384,
LINE_385,
LINE_386,
LINE_387,
LINE_388,
LINE_389,
LINE_390,
LINE_391,
LINE_392,
LINE_393,
LINE_394,
LINE_395,
LINE_396,
LINE_397,
LINE_398,
LINE_399,
LINE_400,
LINE_401,
LINE_402,
LINE_403,
LINE_404,
LINE_405,
LINE_406,
LINE_407,
LINE_408,
LINE_409,
LINE_410,
LINE_411,
LINE_412,
LINE_413,
LINE_414,
LINE_415,
LINE_416,
LINE_417,
LINE_418,
LINE_419,
LINE_420,
LINE_421,
LINE_422,
LINE_423,
LINE_424,
LINE_425,
LINE_426,
LINE_427,
LINE_428,
LINE_429,
LINE_430,
LINE_431,
LINE_432,
LINE_433,
LINE_434,
LINE_435,
LINE_436,
LINE_437,
LINE_438,
LINE_439,
LINE_440,
LINE_441,
LINE_442,
LINE_443,
LINE_444,
LINE_445,
LINE_446,
LINE_447,
LINE_448,
LINE_449,
LINE_450,
LINE_451,
LINE_452,
LINE_453,
LINE_454,
LINE_455,
LINE_456,
LINE_457,
LINE_458,
LINE_459,
LINE_460,
LINE_461,
LINE_462,
LINE_463,
LINE_464,
LINE_465,
LINE_466,
LINE_467,
LINE_468,
LINE_469,
LINE_470,
LINE_471,
LINE_472,
LINE_473,
LINE_474,
LINE_475,
LINE_476,
LINE_477,
LINE_478,
LINE_479,
LINE_480,
LINE_481,
LINE_482,
LINE_483,
LINE_484,
LINE_485,
LINE_486,
LINE_487,
LINE_488,
LINE_489,
LINE_490,
LINE_491,
LINE_492,
LINE_493,
LINE_494,
LINE_495,
LINE_496,
LINE_497,
LINE_498,
LINE_499,
LINE_500,
LINE_501,
LINE_502,
LINE_503,
LINE_504,
LINE_505,
LINE_506,
LINE_507,
LINE_508,
LINE_509,
LINE_510,
LINE_511,
LINE_512,
LINE_513,
LINE_514,
LINE_515,
LINE_516,
LINE_517,
LINE_518,
LINE_519,
LINE_520,
LINE_521,
LINE_522,
LINE_523,
LINE_524,
LINE_525);

signal state, next_state:  lines;
signal tmp: std_logic;
signal  sig_out, sig_out_r: unsigned(7 downto 0);
constant HI_SERR: unsigned(7 downto 0):="00010000";
constant LO_SERR: unsigned(7 downto 0):="00000000";
constant ALL_ZEROS_ADDRESS: unsigned(21 downto 0):="0000000000000000000000";
begin

	seed <= (others=>'1');	-- random number seed is 111...111
	
	-- random number generator module
	
	-- connect internal registers to external busses	
	---- COMMENTED OUT 
	--dOut <= randNum;	-- always output the current random number to the memory
	dOut<="11111111";
	err <= err_r;			-- output the current memory error status
	
addr <= addr_r;		-- memory address bus driven by memory address register
	-- memory test controller state machine operations
	combinatorial: process(state_r,err_r,addr_r,dIn,randNum,ack)
	begin
	
		-- default operations (do nothing unless explicitly stated in the following case statement)
		ldRand <= NO;	-- don't load the random number generator
		ckeRand <= NO;	-- don't generate a new random number
		err_next <= err_r;		-- error flag is unchanged
		state_next <= state_r;	-- no change in memory tester state
		---rd<=NO;
		
		-- **** compute the next state and operations ****
		----case state_r is

			----when INIT =>	-- initialize the memory test controller
				----progress <= "00";		-- indicate the current controller state
				----ldRand <= YES;			-- load random number seed
				----ckeRand <= YES;			-- enable clocking of rand num gen so seed gets loaded
				----addr_next <= TO_UNSIGNED(BEG_TEST,addr_next'length);	-- load starting mem address
				----err_next <= NO;			-- clear memory error flag
				------state_next <= LOAD;	-- go to LOAD state and write pattern to memory
				----state_next<=COMPARE;

			--when LOAD => 	-- load the memory with data from the random number generator
				progress <= "01";		-- indicate the current controller state
				if ack = NO then		-- current write operation is not complete
					---rd<= YES;
				else						-- current write operation is complete
					---wr <= NO;					-- release write signal when write op is complete
					if addr_r /= TO_UNSIGNED(END_TEST,addr_r'length) then
						-- not at the end of the memory test range yet
						--MOVED THIS IN THE NTSC COMBINATIONAL PROCESSS addr_next <= addr_r + 1;	-- so increment address
						ckeRand <= YES;						-- and enable generator clock to get new random num
					else
						-- else end of the memory test range has been reached
						ckeRand <= YES;	-- enable generator clock and
						ldRand <= YES;	-- reload the generator with the seed value
						--MOVED THIS IN THE NTSC COMBINATIONAL PROCESSS addr_next <= TO_UNSIGNED(BEG_TEST,addr'length);	-- reset to start of test range
						state_next <= COMPARE;	-- go to the COMPARE state and check memory contents
					end if;
				end if;

			--when COMPARE =>	-- re-run the generator and compare it to memory contents
				--progress <= "10";		-- indicate the current controller state
				--if ack = NO then		-- current read operation is not complete
					----rd<=YES;
					----rd<=YES;
					--null; -- rd <= YES;				-- keep read signal active since memory read is not done
				--else								-- current read operation is complete
					--rd<=NO;
					---rd<=NO;
					---rd <= NO;					-- release the read signal when read op is complete
					--if dIn /= randNum then	-- compare value from memory to random number
						--err_next <= YES;			-- error if they don't match
					--end if;
					--if addr_r = TO_UNSIGNED(END_TEST,addr_r'length) then
						--state_next <= STOP;	-- go to STOP state once entire range has been checked
					--end if;
					
					--addr_next <= addr_r + 1;	-- increment address to check next memory location
				
					--ckeRand <= YES;						-- and enable generator clock to get next random num
				--end if;

			--when others =>	-- memory test is complete
				--state_next<=COMPARE;
				--progress <= "11";		-- indicate the current controller state
				
		--end case;
end process;


-- update the registers of the memory tester controller	
update: process(clk)
begin
 if clk'event and clk = '1' then
	  if rst = YES then
		  -- go to starting state and clear error flag when reset occurs
		  state_r <= INIT;
		  err_r <= NO;
	  else
		 -- update error flag, address register, and state
		 err_r <= err_next;
		 -- MOVED THIS TO NTSC clked even addr_r <= addr_next;
		 state_r <= state_next;
	  end if;
 end if;
end process;

process(ack)
begin
	if(ack=NO) then
		rd<=YES;
	else
		rd<=NO;
	end if;
end process;

-- NTSC stuff

process(state, counter_r)
begin
		tmp<='1';
data<=sig_out_r;
	next_state <=state;
	counter<=counter_r+1;
	sig_out<=sig_out_r;
	addr_next <= addr_r;  -- next address is the same as current address
case state is 
--- START INSERT	

when LINE_001=>
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_002;
	end if;

when LINE_002=>
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_003;
	end if;

when LINE_003=>
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_004;
	end if;

--- SERRATION PULSES
when LINE_004=>
    tmp<='1';
	if(counter_r = 1365) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r= 1590) then
	sig_out<=LO_SERR;
	end if;
	if (counter_r= 2955) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r =3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_005;
	end if;
	
when LINE_005=>
    tmp<='1';
	if(counter_r = 1365) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r= 1590) then
	sig_out<=LO_SERR;
	end if;
	if (counter_r= 2955) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r =3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_006;
	end if;
when LINE_006=>
	if(counter_r = 1365) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r= 1590) then
	sig_out<=LO_SERR;
	end if;
	if (counter_r= 2955) then
	sig_out<=HI_SERR;
	end if;
	if (counter_r =3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_007;
	end if;
    tmp<='1';


--MORE EQUALIZING PULSES

when LINE_007=>
    tmp<='1';
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_008;
	end if;

when LINE_008=>
    tmp<='1';
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_009;
	end if;

when LINE_009=>
    tmp<='1';
    tmp<='1';
	if (counter_r=115) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r =1590) then
	sig_out <= LO_SERR;
	end if;
	if (counter_r =1705 ) then
	sig_out <= HI_SERR;
	end if;
	if (counter_r = 3180) then
	sig_out<=LO_SERR;
	counter<="000000000000";
	next_state<=LINE_010;
	addr_next <=ALL_ZEROS_ADDRESS;
	end if;

--start generated code


when LINE_010 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_011;
end if;


when LINE_011 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_012;
end if;


when LINE_012 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_013;
end if;


when LINE_013 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_014;
end if;


when LINE_014 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_015;
end if;


when LINE_015 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_016;
end if;


when LINE_016 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_017;
end if;


when LINE_017 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_018;
end if;


when LINE_018 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_019;
end if;


when LINE_019 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_020;
end if;


when LINE_020 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_021;
end if;


when LINE_021 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_022;
end if;


when LINE_022 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_023;
end if;


when LINE_023 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_024;
end if;


when LINE_024 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_025;
end if;


when LINE_025 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_026;
end if;


when LINE_026 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_027;
end if;


when LINE_027 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_028;
end if;


when LINE_028 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_029;
end if;


when LINE_029 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_030;
end if;


when LINE_030 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_031;
end if;


when LINE_031 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_032;
end if;


when LINE_032 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_033;
end if;


when LINE_033 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_034;
end if;


when LINE_034 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_035;
end if;


when LINE_035 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_036;
end if;


when LINE_036 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_037;
end if;


when LINE_037 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_038;
end if;


when LINE_038 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_039;
end if;


when LINE_039 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_040;
end if;


when LINE_040 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_041;
end if;


when LINE_041 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_042;
end if;


when LINE_042 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_043;
end if;


when LINE_043 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_044;
end if;


when LINE_044 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_045;
end if;


when LINE_045 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_046;
end if;


when LINE_046 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_047;
end if;


when LINE_047 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_048;
end if;


when LINE_048 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_049;
end if;


when LINE_049 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_050;
end if;


when LINE_050 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_051;
end if;


when LINE_051 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_052;
end if;


when LINE_052 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_053;
end if;


when LINE_053 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_054;
end if;


when LINE_054 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_055;
end if;


when LINE_055 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_056;
end if;


when LINE_056 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_057;
end if;


when LINE_057 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_058;
end if;


when LINE_058 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_059;
end if;


when LINE_059 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_060;
end if;


when LINE_060 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_061;
end if;


when LINE_061 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_062;
end if;


when LINE_062 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_063;
end if;


when LINE_063 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_064;
end if;


when LINE_064 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_065;
end if;


when LINE_065 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_066;
end if;


when LINE_066 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_067;
end if;


when LINE_067 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_068;
end if;


when LINE_068 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_069;
end if;


when LINE_069 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_070;
end if;


when LINE_070 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_071;
end if;


when LINE_071 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_072;
end if;


when LINE_072 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_073;
end if;


when LINE_073 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_074;
end if;


when LINE_074 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_075;
end if;


when LINE_075 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_076;
end if;


when LINE_076 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_077;
end if;


when LINE_077 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_078;
end if;


when LINE_078 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_079;
end if;


when LINE_079 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_080;
end if;


when LINE_080 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_081;
end if;


when LINE_081 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_082;
end if;


when LINE_082 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_083;
end if;


when LINE_083 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_084;
end if;


when LINE_084 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_085;
end if;


when LINE_085 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_086;
end if;


when LINE_086 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_087;
end if;


when LINE_087 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_088;
end if;


when LINE_088 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_089;
end if;


when LINE_089 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_090;
end if;


when LINE_090 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_091;
end if;


when LINE_091 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_092;
end if;


when LINE_092 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_093;
end if;


when LINE_093 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_094;
end if;


when LINE_094 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_095;
end if;


when LINE_095 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_096;
end if;


when LINE_096 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_097;
end if;


when LINE_097 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_098;
end if;


when LINE_098 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_099;
end if;


when LINE_099 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_100;
end if;


when LINE_100 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_101;
end if;


when LINE_101 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_102;
end if;


when LINE_102 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_103;
end if;


when LINE_103 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_104;
end if;


when LINE_104 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_105;
end if;


when LINE_105 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_106;
end if;


when LINE_106 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_107;
end if;


when LINE_107 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_108;
end if;


when LINE_108 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_109;
end if;


when LINE_109 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_110;
end if;


when LINE_110 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_111;
end if;


when LINE_111 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_112;
end if;


when LINE_112 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_113;
end if;


when LINE_113 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_114;
end if;


when LINE_114 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_115;
end if;


when LINE_115 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_116;
end if;


when LINE_116 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_117;
end if;


when LINE_117 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_118;
end if;


when LINE_118 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_119;
end if;


when LINE_119 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_120;
end if;


when LINE_120 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_121;
end if;


when LINE_121 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_122;
end if;


when LINE_122 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_123;
end if;


when LINE_123 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_124;
end if;


when LINE_124 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_125;
end if;


when LINE_125 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_126;
end if;


when LINE_126 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_127;
end if;


when LINE_127 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_128;
end if;


when LINE_128 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_129;
end if;


when LINE_129 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_130;
end if;


when LINE_130 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_131;
end if;


when LINE_131 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_132;
end if;


when LINE_132 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_133;
end if;


when LINE_133 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_134;
end if;


when LINE_134 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_135;
end if;


when LINE_135 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_136;
end if;


when LINE_136 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_137;
end if;


when LINE_137 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_138;
end if;


when LINE_138 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_139;
end if;


when LINE_139 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_140;
end if;


when LINE_140 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_141;
end if;


when LINE_141 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_142;
end if;


when LINE_142 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_143;
end if;


when LINE_143 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_144;
end if;


when LINE_144 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_145;
end if;


when LINE_145 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_146;
end if;


when LINE_146 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_147;
end if;


when LINE_147 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_148;
end if;


when LINE_148 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_149;
end if;


when LINE_149 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_150;
end if;


when LINE_150 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_151;
end if;


when LINE_151 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_152;
end if;


when LINE_152 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_153;
end if;


when LINE_153 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_154;
end if;


when LINE_154 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_155;
end if;


when LINE_155 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_156;
end if;


when LINE_156 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_157;
end if;


when LINE_157 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_158;
end if;


when LINE_158 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_159;
end if;


when LINE_159 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_160;
end if;


when LINE_160 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_161;
end if;


when LINE_161 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_162;
end if;


when LINE_162 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_163;
end if;


when LINE_163 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_164;
end if;


when LINE_164 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_165;
end if;


when LINE_165 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_166;
end if;


when LINE_166 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_167;
end if;


when LINE_167 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_168;
end if;


when LINE_168 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_169;
end if;


when LINE_169 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_170;
end if;


when LINE_170 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_171;
end if;


when LINE_171 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_172;
end if;


when LINE_172 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_173;
end if;


when LINE_173 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_174;
end if;


when LINE_174 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_175;
end if;


when LINE_175 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_176;
end if;


when LINE_176 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_177;
end if;


when LINE_177 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_178;
end if;


when LINE_178 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_179;
end if;


when LINE_179 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_180;
end if;


when LINE_180 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_181;
end if;


when LINE_181 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_182;
end if;


when LINE_182 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_183;
end if;


when LINE_183 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_184;
end if;


when LINE_184 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_185;
end if;


when LINE_185 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_186;
end if;


when LINE_186 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_187;
end if;


when LINE_187 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_188;
end if;


when LINE_188 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_189;
end if;


when LINE_189 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_190;
end if;


when LINE_190 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_191;
end if;


when LINE_191 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_192;
end if;


when LINE_192 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_193;
end if;


when LINE_193 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_194;
end if;


when LINE_194 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_195;
end if;


when LINE_195 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_196;
end if;


when LINE_196 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_197;
end if;


when LINE_197 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_198;
end if;


when LINE_198 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_199;
end if;


when LINE_199 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_200;
end if;


when LINE_200 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_201;
end if;


when LINE_201 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_202;
end if;


when LINE_202 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_203;
end if;


when LINE_203 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_204;
end if;


when LINE_204 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_205;
end if;


when LINE_205 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_206;
end if;


when LINE_206 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_207;
end if;


when LINE_207 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_208;
end if;


when LINE_208 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_209;
end if;


when LINE_209 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_210;
end if;


when LINE_210 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_211;
end if;


when LINE_211 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_212;
end if;


when LINE_212 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_213;
end if;


when LINE_213 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_214;
end if;


when LINE_214 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_215;
end if;


when LINE_215 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_216;
end if;


when LINE_216 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_217;
end if;


when LINE_217 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_218;
end if;


when LINE_218 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_219;
end if;


when LINE_219 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_220;
end if;


when LINE_220 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_221;
end if;


when LINE_221 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_222;
end if;


when LINE_222 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_223;
end if;


when LINE_223 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_224;
end if;


when LINE_224 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_225;
end if;


when LINE_225 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_226;
end if;


when LINE_226 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_227;
end if;


when LINE_227 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_228;
end if;


when LINE_228 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_229;
end if;


when LINE_229 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_230;
end if;


when LINE_230 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_231;
end if;


when LINE_231 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_232;
end if;


when LINE_232 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_233;
end if;


when LINE_233 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_234;
end if;


when LINE_234 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_235;
end if;


when LINE_235 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_236;
end if;


when LINE_236 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_237;
end if;


when LINE_237 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_238;
end if;


when LINE_238 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_239;
end if;


when LINE_239 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_240;
end if;


when LINE_240 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_241;
end if;


when LINE_241 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_242;
end if;


when LINE_242 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_243;
end if;


when LINE_243 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_244;
end if;


when LINE_244 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_245;
end if;


when LINE_245 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_246;
end if;


when LINE_246 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_247;
end if;


when LINE_247 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_248;
end if;


when LINE_248 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_249;
end if;


when LINE_249 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_250;
end if;


when LINE_250 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_251;
end if;


when LINE_251 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_252;
end if;


when LINE_252 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_253;
end if;


when LINE_253 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_254;
end if;


when LINE_254 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_255;
end if;


when LINE_255 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_256;
end if;


when LINE_256 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_257;
end if;


when LINE_257 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_258;
end if;


when LINE_258 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_259;
end if;


when LINE_259 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_260;
end if;


when LINE_260 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_261;
end if;


when LINE_261 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_262;
end if;


when LINE_262 =>
data<=dIn;
  addr_next<=addr_r +1; -- regardless of ack, hope its ok 
  sig_out<=dIn(7 downto 0);
if (counter_r=3175) then
    counter<="000000000000"; 
    next_state<=LINE_263;
end if;


when LINE_263=>
     sig_out<=LO_SERR;
     counter<= "000000000000"; next_state <= LINE_001;
     tmp<='1';


--End generated code---


when LINE_264=>
    tmp<='1';
when LINE_265=>
    tmp<='1';
when LINE_266=>
    tmp<='1';
when LINE_267=>
    tmp<='1';
when LINE_268=>
    tmp<='1';
when LINE_269=>
    tmp<='1';
when LINE_270=>
    tmp<='1';
when LINE_271=>
    tmp<='1';
when LINE_272=>
    tmp<='1';
when LINE_273=>
    tmp<='1';
when LINE_274=>
    tmp<='1';
when LINE_275=>
    tmp<='1';
when LINE_276=>
    tmp<='1';
when LINE_277=>
    tmp<='1';
when LINE_278=>
    tmp<='1';
when LINE_279=>
    tmp<='1';
when LINE_280=>
    tmp<='1';
when LINE_281=>
    tmp<='1';
when LINE_282=>
    tmp<='1';
when LINE_283=>
    tmp<='1';
when LINE_284=>
    tmp<='1';
when LINE_285=>
    tmp<='1';
when LINE_286=>
    tmp<='1';
when LINE_287=>
    tmp<='1';
when LINE_288=>
    tmp<='1';
when LINE_289=>
    tmp<='1';
when LINE_290=>
    tmp<='1';
when LINE_291=>
    tmp<='1';
when LINE_292=>
    tmp<='1';
when LINE_293=>
    tmp<='1';
when LINE_294=>
    tmp<='1';
when LINE_295=>
    tmp<='1';
when LINE_296=>
    tmp<='1';
when LINE_297=>
    tmp<='1';
when LINE_298=>
    tmp<='1';
when LINE_299=>
    tmp<='1';
when LINE_300=>
    tmp<='1';
when LINE_301=>
    tmp<='1';
when LINE_302=>
    tmp<='1';
when LINE_303=>
    tmp<='1';
when LINE_304=>
    tmp<='1';
when LINE_305=>
    tmp<='1';
when LINE_306=>
    tmp<='1';
when LINE_307=>
    tmp<='1';
when LINE_308=>
    tmp<='1';
when LINE_309=>
    tmp<='1';
when LINE_310=>
    tmp<='1';
when LINE_311=>
    tmp<='1';
when LINE_312=>
    tmp<='1';
when LINE_313=>
    tmp<='1';
when LINE_314=>
    tmp<='1';
when LINE_315=>
    tmp<='1';
when LINE_316=>
    tmp<='1';
when LINE_317=>
    tmp<='1';
when LINE_318=>
    tmp<='1';
when LINE_319=>
    tmp<='1';
when LINE_320=>
    tmp<='1';
when LINE_321=>
    tmp<='1';
when LINE_322=>
    tmp<='1';
when LINE_323=>
    tmp<='1';
when LINE_324=>
    tmp<='1';
when LINE_325=>
    tmp<='1';
when LINE_326=>
    tmp<='1';
when LINE_327=>
    tmp<='1';
when LINE_328=>
    tmp<='1';
when LINE_329=>
    tmp<='1';
when LINE_330=>
    tmp<='1';
when LINE_331=>
    tmp<='1';
when LINE_332=>
    tmp<='1';
when LINE_333=>
    tmp<='1';
when LINE_334=>
    tmp<='1';
when LINE_335=>
    tmp<='1';
when LINE_336=>
    tmp<='1';
when LINE_337=>
    tmp<='1';
when LINE_338=>
    tmp<='1';
when LINE_339=>
    tmp<='1';
when LINE_340=>
    tmp<='1';
when LINE_341=>
    tmp<='1';
when LINE_342=>
    tmp<='1';
when LINE_343=>
    tmp<='1';
when LINE_344=>
    tmp<='1';
when LINE_345=>
    tmp<='1';
when LINE_346=>
    tmp<='1';
when LINE_347=>
    tmp<='1';
when LINE_348=>
    tmp<='1';
when LINE_349=>
    tmp<='1';
when LINE_350=>
    tmp<='1';
when LINE_351=>
    tmp<='1';
when LINE_352=>
    tmp<='1';
when LINE_353=>
    tmp<='1';
when LINE_354=>
    tmp<='1';
when LINE_355=>
    tmp<='1';
when LINE_356=>
    tmp<='1';
when LINE_357=>
    tmp<='1';
when LINE_358=>
    tmp<='1';
when LINE_359=>
    tmp<='1';
when LINE_360=>
    tmp<='1';
when LINE_361=>
    tmp<='1';
when LINE_362=>
    tmp<='1';
when LINE_363=>
    tmp<='1';
when LINE_364=>
    tmp<='1';
when LINE_365=>
    tmp<='1';
when LINE_366=>
    tmp<='1';
when LINE_367=>
    tmp<='1';
when LINE_368=>
    tmp<='1';
when LINE_369=>
    tmp<='1';
when LINE_370=>
    tmp<='1';
when LINE_371=>
    tmp<='1';
when LINE_372=>
    tmp<='1';
when LINE_373=>
    tmp<='1';
when LINE_374=>
    tmp<='1';
when LINE_375=>
    tmp<='1';
when LINE_376=>
    tmp<='1';
when LINE_377=>
    tmp<='1';
when LINE_378=>
    tmp<='1';
when LINE_379=>
    tmp<='1';
when LINE_380=>
    tmp<='1';
when LINE_381=>
    tmp<='1';
when LINE_382=>
    tmp<='1';
when LINE_383=>
    tmp<='1';
when LINE_384=>
    tmp<='1';
when LINE_385=>
    tmp<='1';
when LINE_386=>
    tmp<='1';
when LINE_387=>
    tmp<='1';
when LINE_388=>
    tmp<='1';
when LINE_389=>
    tmp<='1';
when LINE_390=>
    tmp<='1';
when LINE_391=>
    tmp<='1';
when LINE_392=>
    tmp<='1';
when LINE_393=>
    tmp<='1';
when LINE_394=>
    tmp<='1';
when LINE_395=>
    tmp<='1';
when LINE_396=>
    tmp<='1';
when LINE_397=>
    tmp<='1';
when LINE_398=>
    tmp<='1';
when LINE_399=>
    tmp<='1';
when LINE_400=>
    tmp<='1';
when LINE_401=>
    tmp<='1';
when LINE_402=>
    tmp<='1';
when LINE_403=>
    tmp<='1';
when LINE_404=>
    tmp<='1';
when LINE_405=>
    tmp<='1';
when LINE_406=>
    tmp<='1';
when LINE_407=>
    tmp<='1';
when LINE_408=>
    tmp<='1';
when LINE_409=>
    tmp<='1';
when LINE_410=>
    tmp<='1';
when LINE_411=>
    tmp<='1';
when LINE_412=>
    tmp<='1';
when LINE_413=>
    tmp<='1';
when LINE_414=>
    tmp<='1';
when LINE_415=>
    tmp<='1';
when LINE_416=>
    tmp<='1';
when LINE_417=>
    tmp<='1';
when LINE_418=>
    tmp<='1';
when LINE_419=>
    tmp<='1';
when LINE_420=>
    tmp<='1';
when LINE_421=>
    tmp<='1';
when LINE_422=>
    tmp<='1';
when LINE_423=>
    tmp<='1';
when LINE_424=>
    tmp<='1';
when LINE_425=>
    tmp<='1';
when LINE_426=>
    tmp<='1';
when LINE_427=>
    tmp<='1';
when LINE_428=>
    tmp<='1';
when LINE_429=>
    tmp<='1';
when LINE_430=>
    tmp<='1';
when LINE_431=>
    tmp<='1';
when LINE_432=>
    tmp<='1';
when LINE_433=>
    tmp<='1';
when LINE_434=>
    tmp<='1';
when LINE_435=>
    tmp<='1';
when LINE_436=>
    tmp<='1';
when LINE_437=>
    tmp<='1';
when LINE_438=>
    tmp<='1';
when LINE_439=>
    tmp<='1';
when LINE_440=>
    tmp<='1';
when LINE_441=>
    tmp<='1';
when LINE_442=>
    tmp<='1';
when LINE_443=>
    tmp<='1';
when LINE_444=>
    tmp<='1';
when LINE_445=>
    tmp<='1';
when LINE_446=>
    tmp<='1';
when LINE_447=>
    tmp<='1';
when LINE_448=>
    tmp<='1';
when LINE_449=>
    tmp<='1';
when LINE_450=>
    tmp<='1';
when LINE_451=>
    tmp<='1';
when LINE_452=>
    tmp<='1';
when LINE_453=>
    tmp<='1';
when LINE_454=>
    tmp<='1';
when LINE_455=>
    tmp<='1';
when LINE_456=>
    tmp<='1';
when LINE_457=>
    tmp<='1';
when LINE_458=>
    tmp<='1';
when LINE_459=>
    tmp<='1';
when LINE_460=>
    tmp<='1';
when LINE_461=>
    tmp<='1';
when LINE_462=>
    tmp<='1';
when LINE_463=>
    tmp<='1';
when LINE_464=>
    tmp<='1';
when LINE_465=>
    tmp<='1';
when LINE_466=>
    tmp<='1';
when LINE_467=>
    tmp<='1';
when LINE_468=>
    tmp<='1';
when LINE_469=>
    tmp<='1';
when LINE_470=>
    tmp<='1';
when LINE_471=>
    tmp<='1';
when LINE_472=>
    tmp<='1';
when LINE_473=>
    tmp<='1';
when LINE_474=>
    tmp<='1';
when LINE_475=>
    tmp<='1';
when LINE_476=>
    tmp<='1';
when LINE_477=>
    tmp<='1';
when LINE_478=>
    tmp<='1';
when LINE_479=>
    tmp<='1';
when LINE_480=>
    tmp<='1';
when LINE_481=>
    tmp<='1';
when LINE_482=>
    tmp<='1';
when LINE_483=>
    tmp<='1';
when LINE_484=>
    tmp<='1';
when LINE_485=>
    tmp<='1';
when LINE_486=>
    tmp<='1';
when LINE_487=>
    tmp<='1';
when LINE_488=>
    tmp<='1';
when LINE_489=>
    tmp<='1';
when LINE_490=>
    tmp<='1';
when LINE_491=>
    tmp<='1';
when LINE_492=>
    tmp<='1';
when LINE_493=>
    tmp<='1';
when LINE_494=>
    tmp<='1';
when LINE_495=>
    tmp<='1';
when LINE_496=>
    tmp<='1';
when LINE_497=>
    tmp<='1';
when LINE_498=>
    tmp<='1';
when LINE_499=>
    tmp<='1';
when LINE_500=>
    tmp<='1';
when LINE_501=>
    tmp<='1';
when LINE_502=>
    tmp<='1';
when LINE_503=>
    tmp<='1';
when LINE_504=>
    tmp<='1';
when LINE_505=>
    tmp<='1';
when LINE_506=>
    tmp<='1';
when LINE_507=>
    tmp<='1';
when LINE_508=>
    tmp<='1';
when LINE_509=>
    tmp<='1';
when LINE_510=>
    tmp<='1';
when LINE_511=>
    tmp<='1';
when LINE_512=>
    tmp<='1';
when LINE_513=>
    tmp<='1';
when LINE_514=>
    tmp<='1';
when LINE_515=>
    tmp<='1';
when LINE_516=>
    tmp<='1';
when LINE_517=>
    tmp<='1';
when LINE_518=>
    tmp<='1';
when LINE_519=>
    tmp<='1';
when LINE_520=>
    tmp<='1';
when LINE_521=>
    tmp<='1';
when LINE_522=>
    tmp<='1';
when LINE_523=>
    tmp<='1';
when LINE_524=>
    tmp<='1';
when LINE_525=>
    tmp<='1';
--- END   INSERT	

when others=>
	next_state<=LINE_001;
end case;

end process;

process (ntsc_clk)
begin
if (reset='0') 
then
	null;
elsif(ntsc_clk'event and ntsc_clk='1')
then
	state<=next_state;
	counter_r <= counter;
	sig_out_r<=sig_out;
	 addr_r <= addr_next;
end if;
end process;


wr <= NO;	-- DO NOT WRITE TO SDRAM

end arch;
